{#-

    This helper macro is responsible for rendering small informational paragraph
    about report severity.

-#}

{%- macro render_info_severity(report, text_width=none) %}
{% if report.severity == 'low' -%}
    {% set text = gettext('This report contains events with LOW severity. Please consider reviewing the host systems mentioned in this report and fix any possible issues.') %}
{%- elif report.severity == 'medium' -%}
    {% set text = gettext('This report contains events with MEDIUM severity. Please review the host systems mentioned in this report and fix the issues.') %}
{%- elif report.severity == 'high' -%}
    {% set text = gettext('This report contains events with HIGH severity. Please take action immediatelly.') %}
{%- elif report.severity == 'critical' -%}
    {% set text = gettext('This report contains events with CRITICAL severity. Please take action immediatelly.') %}
{%- else -%}
    {% set text = none %}
{%- endif -%}
{%- if text -%}
    {%- if text_width -%}
        {{ text | wordwrap(width=text_width, break_long_words=False) }}
    {%- else -%}
        {{ text }}
    {%- endif %}
{% endif %}
{%- endmacro %}

{%- macro render_report_section(section_number, additional_vars, event_classes_data, section_name, section_data, text_width, logger) %}

{% if event_classes_data[section_name] is defined and event_classes_data[section_name]["label"] is defined -%}
    {% set section_label = event_classes_data[section_name]["label"] -%}
{% else -%}
    {% set section_label = event_classes_data[additional_vars["default_event_class"]]["label"] -%}
    {% if logger -%}
        {% set phony = logger.warning('Report section label for event class "' ~ section_name ~ '" does not exist, using fallback report label.') -%}
    {% endif -%}
{% endif -%}
{% if event_classes_data[section_name] is defined and event_classes_data[section_name]["reference"] is defined -%}
    {% set section_reference = event_classes_data[section_name]["reference"] -%}
{% else -%}
    {% set section_reference = event_classes_data[additional_vars["default_event_class"]]["reference"] -%}
    {% if logger -%}
        {% set phony = logger.warning('Report section reference for event class "' ~ section_name ~ '" does not exist.') -%}
    {% endif -%}
{% endif -%}
{% if event_classes_data[section_name] is defined and event_classes_data[section_name]["has_macro"] -%}
    {% from section_name + "/email.j2" import header, row -%} 
{% endif -%}
{% if header is undefined -%}
    {% from additional_vars['default_event_class'] + "/email.j2" import header as header -%}
{% endif -%}
{% if row is undefined -%}
    {% from additional_vars['default_event_class'] + "/email.j2" import row as row -%}
{% endif -%}
{% set tmp = additional_vars.__setitem__("longest_key", 0) -%}
{% for k in section_data -%}
    {% set tmp = additional_vars.__setitem__("longest_key",  ([additional_vars["longest_key"], (k|length)]|max)) -%}
{% endfor -%}

{{ '[' ~ section_number ~ '] ' ~ _(section_label) | wordwrap(width=text_width, break_long_words=False) }}

    {% set h = header(additional_vars) -%}{{ h }}
    {{ '{}'.format('─' * h|length) }}
{%- for ip in section_data | dictsort %}
    {{ row(ip[0], ip[1], additional_vars) }}
{%- endfor %}
    {{ '{}'.format('─' * h|length) }}
{% if section_reference %}
    {{ _('More information:') }}  {{ section_reference }}
{%- endif %}
{%- endmacro %}
